<?php
/*
// =========================================================
// 名刺管理システムphpスクリプト
// Copyright (c) 2006 Saito IT Management All Rights Reserved
// Ver.
//	0.1.0	2006-02-09
//  1.0.0	2006-02-17
// =========================================================
*/

//実際の運用時
error_reporting(E_ALL & ~E_NOTICE & ~E_WARNING);

mb_internal_encoding("UTF-8");

define("G_APPNAME", "名刺管理システム Castle");    // アプリケーション名
define("G_COPYR", "Copyright &copy; 2006 Saito IT Management All Rights Reserved");    // コピーライト
define("G_DEFSCR", "log");    // デフォルト画面
define("G_CDISP", "UTF-8");    // 表示文字コード
define("G_ENCDB", "UTF-8");    // データベース文字コード
define("G_LOGID", "login1");    // login ID
define("G_LOGPA", "login1");    // login password
define("G_DBNAME", "./data/csdata.sqlite");    // SQLiteデータベースファイル


// セッションの開始
session_cache_limiter("public");
session_start();

//キャッシュを捨てるおまじない
//header("Content-Type: text/html; charset=EUC-JP");
header("Content-Type: text/html; charset=UTF-8");
header("Expires: Sat, 01 Jan 2000 00:00:00 GMT");             // Date in the past
header("Last-Modified: ". gmdate("D, d M Y H:i:s"). " GMT");  // always modified
header("Cache-Control: no-store, no-cache, must-revalidate");
header("Cache-Control: post-check=0, pre-check=0", false);
header("Pragma: no-cache");

// ===========================================
// 　初期パラメータ
// ===========================================
// フォームデータ変換
$prmarray = cnv_formstr($_POST);

if(!chk_auth($prmarray)){
    $act = G_DEFSCR;
}elseif(isset($prmarray["act"])) {
	if("1" == $prmarray["logoff"]){
		$_SESSION["id"]="";
		$_SESSION["pass"]="";
		$_SESSION["srch"]="";
		$_SESSION["act"] = "log";
		header("Location: ./index.php");
	}else{
		if(!$prmarray["act"] or ($prmarray["act"] == "src")){
			$act = "admin";
		}else{
			$act = $prmarray["act"];
		}
	}
}else{
    $act = G_DEFSCR;
}

?>
<?php $dbcon = db_open(); ?>
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8">
<meta http-equiv='expires' content='0'>
<meta http-equiv='Pragma' content='no-cache'>
<title><?=G_APPNAME?></title>
<script language="javascript">
<!-- //

// -->
</script>
<link rel="stylesheet" href="css.css" type="text/css" />
</head>
<body>
<?php
// 画面表示ルーチンの呼び出し
call_user_func("screen_".$act, $prmarray);
?>

</body>
</html>
<?php db_close($dbcon); ?>

<?php
// =================================================
// -----　ログイン画面
// =================================================
function screen_log($array) {
	global $dbcon;
?>

<table cellspacing="0" class="mainbody">
  <tr>
    <td class="topsizer">&nbsp;</td>
  </tr>
  <tr>
    <td class="topsize"><b><?=G_APPNAME?></b></td>
  </tr>
  <tr>
    <td class="topsizer"><?=G_COPYR?></td>
  </tr>
  <tr>
    <td>&nbsp;</td>
  </tr>
  <tr>
    <td>
    <?php include "frm_login.php"; ?>
    </td>
  </tr>
</table>

<?php
}

// =================================================
// -----　メイン画面
// =================================================
function screen_admin($array) {
	global $dbcon;

if(!$_SESSION["id"]) { return;	}
if(!$_SESSION["pass"]) { return;	}

	if($_POST["dkbn"]){
		if("add" == $_POST["dkbn"]){
			if($_POST["u_nm"] and $_POST["u_hi"]){

				if(!$dbcon){
				    $dbcon = sqlite_open(G_DBNAME);
				    if($dbcon == FALSE){
			    		exit;
					}else{
					}
				}else{
				}
				
				/////////////////////////////////////
				$sql = "SELECT MAX(t_id) FROM data";
				$errmg = "select error -0400";
				$result =  db_select($dbcon, $sql, $errmg);
				if($result){
					
					$recnm = intval($result[0]["MAX(t_id)"]);
					$recnm++;
				}else{
					$recnm=1;
				}
					$sql2 = "INSERT INTO data ";
					$sql2 .= "VALUES ( ";
					$sql2 .= "".$recnm.", ";
					$sql2 .= "'".$_POST['u_cn']."', ";
					$sql2 .= "'".$_POST['u_dn']."', ";
					$sql2 .= "'".$_POST['u_nm']."', ";
					$sql2 .= "'".$_POST['u_hi']."', ";
					$sql2 .= "'".$_POST['u_em']."', ";
					$sql2 .= "'".$_POST['u_tl']."', ";
					$sql2 .= "'".$_POST['u_fx']."', ";
					$sql2 .= "'".$_POST['u_pt']."', ";
					$sql2 .= "'".$_POST['u_at']."', ";
					$sql2 .= "'".$_POST['u_ul']."', ";
					$sql2 .= "'".$_POST['u_me']."')";

					$resl = sqlite_query($dbcon, $sql2);
					if(!$resl){
						echo "insert error ?<br>";
						echo sqlite_error_string(sqlite_last_error($dbcon))."<br>";						
					}
			}
		}else if("upd" == $_POST["dkbn"]){
			//update
	        $sql3 = "UPDATE data";
			$sql3 .= " SET ";
			$sql3 .= " t_cn = '".cnv_sqlstr($_POST['u_cn'])."',";
			$sql3 .= " t_dn = '".cnv_sqlstr($_POST['u_dn'])."',";
			$sql3 .= " t_nm = '".cnv_sqlstr($_POST['u_nm'])."',";
			$sql3 .= " t_hi = '".cnv_sqlstr($_POST['u_hi'])."',";
			$sql3 .= " t_em = '".cnv_sqlstr($_POST['u_em'])."',";
			$sql3 .= " t_tl = '".cnv_sqlstr($_POST['u_tl'])."',";
			$sql3 .= " t_fx = '".cnv_sqlstr($_POST['u_fx'])."',";
			$sql3 .= " t_pt = '".cnv_sqlstr($_POST['u_pt'])."',";
			$sql3 .= " t_at = '".cnv_sqlstr($_POST['u_at'])."',";
			$sql3 .= " t_ul = '".cnv_sqlstr($_POST['u_ul'])."',";
			$sql3 .= " t_me = '".cnv_sqlstr($_POST['u_me'])."'";
			$sql3 .= " WHERE t_id = ".$_POST['cno'];
			$result = sqlite_query($dbcon, $sql3);
			if(!$result){
				echo "upd error -0800<br>";
			}
		}else if("del" == $_POST["dkbn"]){
			//del
			$sql4 = "DELETE FROM data";
			$sql4 .= " WHERE t_id = ".$_POST['cno'];
			sqlite_query($dbcon, $sql4);
		}else if("srch" == $_POST["dkbn"]){
			echo $_POST["dkbn"]." :=dkbn4<br>";
		}
	}

?>

<table cellspacing="0" class="mainbody">
  <tr>
    <td class="topsizer">&nbsp;</td>
  </tr>
  <tr>
    <td class="topsize"><b><?=G_APPNAME?></b></td>
  </tr>
  <tr>
    <td class="topsizer"><?=G_COPYR?></td>
  </tr>
 <tr>
    <td valign="top" class="leftmainsize"><?php include "frm_menu.php"; ?><br></td>
  </tr>
</table>


<?php
}


// =================================================
// -----　顧客追加／変更／削除画面
// =================================================
function screen_aud($array) {
	global $dbcon;

if(!$_SESSION["id"]) { return;	}
?>

<table cellspacing="0" class="mainbody">
  <tr>
    <td class="topsizer">&nbsp;</td>
  </tr>
  <tr>
    <td class="topsize"><b><?=G_APPNAME?></b></td>
  </tr>
  <tr>
    <td class="topsizer"><?=G_COPYR?></td>
  </tr>
  <tr>
    <td valign="top" class="leftmainsize"><?php include "audcust.php"; ?><br></td>
  </tr>
  <tr>
    <td class="btmsize">&nbsp;</td>
  </tr>
</table>


<?php
}

// =========================================================
// ユーザ権限チェック
// =========================================================
function chk_auth($array) {

	global $dbcon;
	$flg=FALSE;

	if($_SESSION["id"] and $_SESSION["pass"]){
		return TRUE;
	}

	if(!$dbcon){
	    $dbcon = sqlite_open(G_DBNAME);
	    if($dbcon == FALSE){
			echo cnv_dispstr("DB open error -0100<br>");
	    	exit;
	    }else{
	    }
	}
	$sql = "SELECT * FROM acct";
	$db_err_msg = "DB select error -0200";
	$result = db_select($dbcon, $sql, $db_err_msg);
	if(!$result){
//	   	echo "sts-0100<br>";
//		echo $dberror."<br>";
	}else{
		for($i=0; $i<count($result);$i++){
			
			if(cnv_dispstr($result[$i]['id']) == $_POST["id"] and
				cnv_dispstr($result[$i]['pass']) == $_POST["pass"]){
				$_SESSION["id"]=cnv_dispstr($result[$i]['id']);
				$_SESSION["pass"]=cnv_dispstr($result[$i]['pass']);
				$_SESSION["srch"]="all";
				$flg=TRUE;
			}
		}
		
	}

	return $flg;
	
}

// =================================================
// -----　データ一覧表示（顧客リスト）
// =================================================
function disp_custlist($array) {
	global $dbcon;

	$no = 1;
	
	if(!$dbcon){
			echo "DB CLOSED! -0500<br>";
	    $dbcon = sqlite_open(G_DBNAME);
	    if($dbcon == FALSE){
			echo cnv_dispstr("DB open error -0510<br>");
		   	exit;
	 	}else{
			echo "dbcon(0520)=: ".$dbcon."<br>";
		}
	}

	if(!$_POST["srh"]){
		if($_SESSION["srch"]){
			$_POST['srh']=$_SESSION["srch"];
		}
	}

?>
	<div class="contents1">
	<table cellpadding="0" cellspacing="0">
    <tr class="contentsname1">
    <td rowspan="4" width="60">&nbsp;</td>
    <td colspan="2">会社名</td>
    <td colspan="2">部門名</td>
    </tr>
    <tr class="contentsname1">
    <td>名前</td>
    <td>ひらがな</td>
    <td>電話番号</td>
    <td>Fax番号</td>
    </tr>
    <tr class="contentsname1">
    <td>e-mail</td>
    <td nowrap>郵便番号</td>
    <td nowrap colspan="2">住所</td>
    </tr>
    <tr class="contentsname1">
    <td>url</td>
    <td colspan="3">メモ</td>
    </tr>
	</table>
	</div>

	<div class="contents1">
	<table cellpadding="0" cellspacing="0" border=1>
<?php
	$srchstr="";
	if($_POST['srh']){
		switch ($_POST['srh']){
		 case "all":
			$srchstr="";
		 	break;
		 case "a":
			$srchstr="~あいうえお";
		 	break;
		 case "ka":
			$srchstr="~かきくけこがぎぐげご";
		 	break;
		 case "sa":
			$srchstr="~さしすせそざじずぜぞ";
		 	break;
		 case "ta":
			$srchstr="~たちつてとだぢづでど";
		 	break;
		 case "na":
			$srchstr="~なにぬねの";
		 	break;
		 case "ha":
			$srchstr="~はひふへほばびぶべぼぱぴぷぺぽ";
		 	break;
		 case "ma":
			$srchstr="~まみむめも";
		 	break;
		 case "ya":
			$srchstr="~やゆよ";
		 	break;
		 case "ra":
			$srchstr="~らりるれろ";
		 	break;
		 case "wa":
			$srchstr="~わをん";
		 	break;
		 case "oth":
			$srchstr="~あいうえおかきくけこがぎぐげごさしすせそざじずぜぞたちつてとだぢづでどなにぬねのはひふへほばびぶべぼぱぴぷぺぽまみむめもやゆよらりるれろわをん";
		 	break;
		 default:
		 	break;
		 }
	}

	$sql = "SELECT * FROM data";
	$db_err_msg = "DB select error -0530";
	$result = db_select($dbcon, $sql, $db_err_msg);
	if(!$result){
	}else{
		for($i=0; $i<count($result);$i++){
			if(
			(0 != mb_strrpos($srchstr,mb_substr(cnv_dispstr($result[$i]['t_hi']), 0, 1)) and $_POST['srh']=="a")
			or (0 != mb_strrpos($srchstr,mb_substr(cnv_dispstr($result[$i]['t_hi']), 0, 1)) and $_POST['srh']=="ka")
			or (0 != mb_strrpos($srchstr,mb_substr(cnv_dispstr($result[$i]['t_hi']), 0, 1)) and $_POST['srh']=="sa")
			or (0 != mb_strrpos($srchstr,mb_substr(cnv_dispstr($result[$i]['t_hi']), 0, 1)) and $_POST['srh']=="ta")
			or (0 != mb_strrpos($srchstr,mb_substr(cnv_dispstr($result[$i]['t_hi']), 0, 1)) and $_POST['srh']=="na")
			or (0 != mb_strrpos($srchstr,mb_substr(cnv_dispstr($result[$i]['t_hi']), 0, 1)) and $_POST['srh']=="ha")
			or (0 != mb_strrpos($srchstr,mb_substr(cnv_dispstr($result[$i]['t_hi']), 0, 1)) and $_POST['srh']=="ma")
			or (0 != mb_strrpos($srchstr,mb_substr(cnv_dispstr($result[$i]['t_hi']), 0, 1)) and $_POST['srh']=="ya")
			or (0 != mb_strrpos($srchstr,mb_substr(cnv_dispstr($result[$i]['t_hi']), 0, 1)) and $_POST['srh']=="ra")
			or (0 != mb_strrpos($srchstr,mb_substr(cnv_dispstr($result[$i]['t_hi']), 0, 1)) and $_POST['srh']=="wa")
			or (0 == mb_strrpos($srchstr,mb_substr(cnv_dispstr($result[$i]['t_hi']), 0, 1)) and $_POST['srh']=="oth")
			or ($_POST['srh']=="all")){
			if(1==1){
	
				if(1 == $no%2){
?>
				    <tr class="contentsname2">
<?php
				}else{
?>
			    	<tr class="contentsname3">
<?php
				}
?>
		    <td rowspan="4" width="60">
			<form method="POST" action="<?=$_SERVER["PHP_SELF"]?>">
			<span class="btn_out3"><input type="submit" value="変更"></span>
			<input type="hidden" name="act" value="aud">
			<input type="hidden" name="kbn" value="upd">
	    <input type="hidden" name="cno" value="<?=$result[$i]['t_id']?>">
        <!-- 更新を選択されたid -->
        <input type="hidden" name="id" value="<?=$_POST['id']?>">
		<input type="hidden" name="logoff" value="0">
        </form>
        <form method="POST" action="<?=$_SERVER["PHP_SELF"]?>">
        <span class="btn_out3"><input type="submit" value="削除"></span>
        <!-- 管理項目 -->
		<input type="hidden" name="act" value="aud">
	    <input type="hidden" name="kbn" value="del">
	    <input type="hidden" name="cno" value="<?=$result[$i]['t_id']?>">
        <!-- 更新を選択されたid -->
        <input type="hidden" name="id" value="<?=$_POST['id']?>">
		<input type="hidden" name="logoff" value="0">
        </form>
			</td>
			<td colspan="2">
<?php
				if($result[$i]['t_cn']){
?>
				    <?=cnv_dispstr($result[$i]['t_cn'])?>
<?php
				}else{
?>
			    	&nbsp;
<?php
				}
?>
			</td>
			<td colspan="2">
<?php
				if($result[$i]['t_dn']){
?>
				    <?=cnv_dispstr($result[$i]['t_dn'])?>
<?php
				}else{
?>
			    	&nbsp;
<?php
				}
?>
			</td>
		</tr>
<?php
				if(1 == $no%2){
?>
			    	<tr class="contentsname2">
<?php
				}else{
?>
			    	<tr class="contentsname3">
<?php
				}
?>
		    <td>
<?php
				if($result[$i]['t_nm']){
?>
				    <?=cnv_dispstr($result[$i]['t_nm'])?>
<?php
				}else{
?>
			    	&nbsp;
<?php
				}
?>
		    </td>
			<td>
<?php
				if($result[$i]['t_hi']){
?>
				    <?=cnv_dispstr($result[$i]['t_hi'])?>
<?php
				}else{
?>
			    	&nbsp;
<?php
				}
?>
			</td>
			<td>
<?php
				if($result[$i]['t_tl']){
?>
				    <?=cnv_dispstr($result[$i]['t_tl'])?>
<?php
				}else{
?>
			    	&nbsp;
<?php
				}
?>
			</td>
			<td>
<?php
				if($result[$i]['t_fx']){
?>
				    <?=cnv_dispstr($result[$i]['t_fx'])?>
<?php
				}else{
?>
			    	&nbsp;
<?php
				}
?>
			</td>
		</tr>
<?php
				if(1 == $no%2){
?>
				    <tr class="contentsname2">
<?php
				}else{
?>
				    <tr class="contentsname3">
<?php
				}
?>
			<td>
<?php
				if($result[$i]['t_em']){
?>
				    <?=cnv_dispstr($result[$i]['t_em'])?>
<?php
				}else{
?>
			    	&nbsp;
<?php
				}
?>
			</td>
			<td>
<?php
				if($result[$i]['t_pt']){
?>
				    <?=cnv_dispstr($result[$i]['t_pt'])?>
<?php
				}else{
?>
			    	&nbsp;
<?php
				}
?>
			</td>
			<td colspan="2">
<?php
				if($result[$i]['t_at']){
?>
				    <?=cnv_dispstr($result[$i]['t_at'])?>
<?php
				}else{
?>
			    	&nbsp;
<?php
				}
?>
			</td>
		</tr>
<?php
			if(1 == $no%2){
?>
			    <tr class="contentsname2">
<?php
			}else{
?>
			    <tr class="contentsname3">
<?php
			}
?>
			<td>
<?php
				if($result[$i]['t_ul']){
?>
				    <?=cnv_dispstr($result[$i]['t_ul'])?>
<?php
				}else{
?>
			    	&nbsp;
<?php
				}
?>
			</td>
			<td colspan="3">
<?php
				if($result[$i]['t_me']){
?>
				    <?=cnv_dispstr($result[$i]['t_me'])?>
<?php
				}else{
?>
			    	&nbsp;
<?php
				}
?>
			</td>
		</tr>
	
<?php
			$no++;
			$result[$i]['t_cn']="";
			$result[$i]['t_dn']="";
			$result[$i]['t_nm']="";
			$result[$i]['t_hi']="";
			$result[$i]['t_em']="";
			$result[$i]['t_tl']="";
			$result[$i]['t_fx']="";
			$result[$i]['t_pt']="";
			$result[$i]['t_at']="";
			$result[$i]['t_ul']="";
			$result[$i]['t_me']="";
		
			}//$$result[$i]['t_cn']
			}
		}//for($i=0; $i<count($result);$i++)
	}//(!$result)
?>
	</table>
	</div>

<?php
	return;
}


// =========================================================
// 表示する文字コードに変換
// =========================================================
function cnv_dispstr($string) {
    // 文字コードを変換する
    $det_enc = mb_detect_encoding($string, "UTF-8, EUC-JP, SJIS, ASCII");
    if ($det_enc  and $det_enc != G_CDISP) {
        return mb_convert_encoding($string, G_CDISP, $det_enc);
    }
    else {
        return $string;
    }
}

// =========================================================
// 配列データを一括変換
// =========================================================
function cnv_formstr($array) {

    foreach($array as $k => $v){
        // 「magic_quotes_gpc = On」のときはエスケープ解除
        if (get_magic_quotes_gpc()) {
            $v = stripslashes($v);
        }
        
        $v = htmlspecialchars($v);
        $array[$k] = $v;
    }
    return $array;
}

// =========================================================
// データをSQL用に変換
// =========================================================
function cnv_sqlstr($string) {
    // 文字コードを変換する
    $det_enc = mb_detect_encoding($string, "UTF-8, EUC-JP, SJIS, ASCII");
    if ($det_enc  and $det_enc != G_ENCDB) {
        $string = mb_convert_encoding($string, G_ENCDB, $det_enc);
    }
    // バックスラッシュを付加する
    $string = addslashes($string);
    return $string;
}


// =================================================
// -----　SQLite db open
// =================================================
function db_open() {

if ($db = sqlite_open(G_DBNAME, 0666, $sqliteerror)) { 
  sqlite_query($db,'CREATE TABLE acct (id varchar(32) primary key, pass  varchar(32), rank smallint)');
  sqlite_query($db,"INSERT INTO acct (id, pass, rank) VALUES ('".G_LOGID."', '".G_LOGPA."', 0)");
  sqlite_query($db,'CREATE TABLE data (t_id integer not null primary key, t_cn varchar(128) not null, t_dn varchar(128) not null, t_nm varchar(128) not null, t_hi varchar(128) not null, t_em varchar(64) not null, t_tl varchar(32) not null, t_fx varchar(32) not null, t_pt varchar(10) not null, t_at varchar(255) not null, t_ul varchar(128) not null, t_me varchar(255) not null)');
    return $db;
} else {
  die ($sqliteerror);
}

}

// =================================================
// -----　SQLite db select
// =================================================
function db_select($dbres, $sql, $dberror) {

	$result = sqlite_query($dbres, $sql);
	if(!$result){
//	   	echo "error sts-0100<br>";
//		echo $dberror."<br>";
		return;
	}else{
		while($result_row = sqlite_fetch_array($result)){
			$select_data[] = $result_row;
		}
		return $select_data;
	}
}


// =================================================
// -----　db close
// =================================================
function db_close($dbconu) {
    // 接続を解除する
    sqlite_close($dbconu);
}

?>